'************************************************************************************
' QI_tel_02.bas    (Q 02)MultiMasterSlave                                    11.2.14*
'************************************************************************************

$regfile = "m8def.dat"
$crystal = 8000000                                ' interner RC-Osz. wird verwendet
$baud = 1200                                      ' fr AFSK

$framesize = 48
$swstack = 48
$hwstack = 48

'-------------- Slave Adressen ----------
Const Sync_adr = &H68                             ' Sync-Auswertung (104)
Const Vmx_adr = &H62                              ' VideoMatrix Basisadresse (98)
Const Amx_adr = &H64                              ' AudioMatrix Basisadresse (100)
Const Rel_adr = &H66                              ' Relaisbox Adresse (102)

'******************************************************************************************************
'Config Com1 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 2 , Databits = 8 , Clockpol = 0
'***** nur mit 2 Stop-Bits dekodiert M8 per Software (trotzdem noch wacklig) *****

'**************************************************************************************************
'***************************** TWI setup **********************************************************
'**************************************************************************************************
Config Twi = 65000                                ' 65 kHz
$include "tomTWI.bas"                             ' im selben Verzeichnis
Twcr = &B00000100                                 ' TWI gleich einschalten (nur TWEN setzen)
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
On Twi Twi_mst_slv_isr , Nosave                   'ISR f. TWI    +++++++ DAS MUSS DRIN SEIN +++++++++
'****************************************************************************************************

'***************************** Setup als Slave ******************************************************
Twi_slv_addr = &H70                               ' eigene Slave Adresse (112)
Dim Twi_mst_buff(1) As Byte                       '

Dim Twi_sr_buff(32) As Byte                       ' fr empfangenes byte
Dim Twi_st_buff(2) As Byte                        ' fr zu sendende bytes (des slave)
Twi_sr_data = Varptr(twi_sr_buff(1))              ' Datenpuffer Empfang als slave
Twi_st_data = Varptr(twi_st_buff(1))              ' Datenbuffer Senden als slave
Twar = Twi_slv_addr                               ' I2C Adresse OHNE GCA
Gosub Twi_sense                                   ' Aktivierung der slave Funktion

Dim Masterbyte(5) As Byte                         ' array der als Slave empfangenen bytes

'***************************** A/V MUX, Relaisbox, PCF8574 *****************************************
Dim Twi_vmx_buff(16) As Byte                      ' ..fr Vmux bytes
Dim Twi_amx_buff(32) As Byte                      ' dasselbe fr Audiodaten
Dim Twi_sync_buff(3) As Byte                      ' Buffer fr Sync byte (Sync-Muster, -Status,- Timer)
Dim Twi_rel_buff(2) As Byte                       ' fr Relais-Status

Dim Telegramm(60) As Byte                         ' Daten fr AFSK
Dim Prfsumme As Word

Dim Fehler_flag As Byte                           ' zum Loop-Abbruch und Neustart
Dim Schleifen As Byte                             ' fr Schleifenzhler

'********************** Allgemeine Variable ***********************************
Dim Daten_lesen As Bit                            ' flag zum Auslesen der Daten
Dim Daten_senden As Bit                           ' flag zum Senden der Daten
Dim N As Byte                                     ' Zhlvariable

'*************************************************************************
'***************************** Initialisierung ***************************
'*************************************************************************
'$sim
Osccal = &HC2                                     ' int. RC-Osz. Kalibrierung

Enable Interrupts

Schleifen = 10                                   ' ...bis zur Fehlermeldung
Daten_lesen = 0
Daten_senden = 0

'***************************************************************************
'*********************************** MAIN **********************************
'***************************************************************************

Do
   '------ slave auswerten ------
   If Twi_slv_flag <> 0 Then                      ' ist beim slave was passiert?
      Gosub Slave_rxtx                            ' ja, dann auswerten
   End If
   '-----------------------------
   If Daten_lesen = 1 Then
      Gosub Video_lesen                           ' Vmux
      Gosub Audio_lesen                           ' Amux
      Gosub Sync_lesen                            ' Sync-Status
      Gosub Relais_lesen
      Daten_lesen = 0                             ' flag zurcksetzen
      Daten_senden = 1                            ' flag setzen
   End If

   If Daten_senden = 1 Then
      Gosub Daten_ausgeben                        ' als TTL an den XR2206 Encoder
      Daten_senden = 0                            ' flag zurcksetzen
   End If

Loop

End

'*********************************************************************************
'*************************** ISR / Subs etc. *************************************
'*********************************************************************************

'+++++++++++++++++++++++++++ MMSlave-Funktion RX/TX byte +++++++++++++++++++++++++
Slave_rxtx:

   Select Case Twi_slv_flag
      Case &H60
         For N = 1 To Twi_sr_cntr
            Masterbyte(n) = Twi_sr_buff(n)        ' array fllen
         Next N

         Select Case Masterbyte(1)
            Case 57                               ' = asc("9")  (Daten auslesen/sammeln)
               Daten_lesen = 1
         End Select
      Case &HA8                                   ' es ist was abgeholt worden
         nop                                      ' "hier" wurden die Daten aus Twi_st_buff(n)abgeholt
   End Select                                     ' z.B Twi_mst_flag

   Twi_slv_flag = 0                               ' quittieren
   Twi_slv_stat = 0                               ' dto.
   Gosub Twi_sense                                ' Slave wieder scharfmachen
Return

'*************************** Daten ausgeben **************************************
Daten_ausgeben:

   For N = 1 To 16
      Telegramm(n) = Twi_vmx_buff(n)
   Next N

   For N = 1 To 32
      Telegramm(n + 16) = Twi_amx_buff(n)
   Next N

   For N = 1 To 3
      Telegramm(n + 48) = Twi_sync_buff(n)
   Next N

   For N = 1 To 2
      Telegramm(n + 51) = Twi_rel_buff(n)
   Next N

   For N = 1 To 53
      Prfsumme = Prfsumme + Telegramm(n)
   Next N

   Prfsumme = Prfsumme Mod 256
   Telegramm(54) = Prfsumme
   Printbin Telegramm(1) ; 54
   Prfsumme = 0
Return

'+++++++++++++++++++++++ VMux auslesen  MMaster TX/RX ++++++++++++++++++++++++++++
Video_lesen:
   Twi_mst_buff(1) = 65
   ' Video Matrix auslesen und speichern
   Fehler_flag = 0
   Do
      If Fehler_flag = Schleifen Then Goto Raus1
      Twi_mst_addr = Vmx_adr                      ' Video-slave
      Twi_mt_cntr = 1
      Twi_mt_data = Varptr(twi_mst_buff(1))       ' 65       ' Leseanforderung an den slave

      Twi_mr_cntr = 16                            ' 16 bytes anfordern/empfangen (repeat start)
      Twi_mr_data = Varptr(twi_vmx_buff(1))       ' Puffer fr Videodaten
      Gosub Run_wait_master
   Loop Until Twi_mst_flag = 0

Raus1:
Return

'+++++++++++++++++++++++ AMux auslesen  MMaster TX/RX ++++++++++++++++++++++++++++
Audio_lesen:                                      ' Audio Mischer auslesen und speichern
   Twi_mst_buff(1) = 65

   Fehler_flag = 0
   Do
      If Fehler_flag = Schleifen Then Goto Raus2
      Twi_mst_addr = Amx_adr                      ' Audio-slave
      Twi_mt_cntr = 1
      Twi_mt_data = Varptr(twi_mst_buff(1))       '  nicht einfach 65 !!!  Leseanforderung an den slave

      Twi_mr_cntr = 32                            ' 32 bytes anfordern/empfangen (repeat start)
      Twi_mr_data = Varptr(twi_amx_buff(1))       ' Puffer fr Audiodaten
      Gosub Run_wait_master
   Loop Until Twi_mst_flag = 0

Raus2:
Return

'+++++++++++++++++++++++++ Sync/Timer auslesen = MMaster RX only +++++++++++++++++
Sync_lesen:                                       '

   Fehler_flag = 0                                ' Anfangswert
   Do                                             '
      If Fehler_flag = Schleifen Then Goto Raus3  ' nach n Versuchen aufgeben
      Twi_mst_addr = Sync_adr + 1                 ' Sync Adresse + 1
      Twi_mr_cntr = 3                             ' n Bytes (Muster, Status, Timer)
      Twi_mr_data = Varptr(twi_sync_buff(1))      ' Empfangsbuffer
      Gosub Run_wait_master                       ' auf gehts
   Loop Until Twi_mst_flag = 0
Raus3:
Return

'+++++++++++++++++++++++ Relaisbox auslesen  MMaster TX/RX +++++++++++++++++++++++
Relais_lesen:
   Twi_mst_buff(1) = 65

   Fehler_flag = 0
   Do
      If Fehler_flag = Schleifen Then Goto Raus4
      Twi_mst_addr = Rel_adr                      ' Relais-slave
      Twi_mt_cntr = 1
      Twi_mt_data = Varptr(twi_mst_buff(1))       ' Leseanforderung an den slave

      Twi_mr_cntr = 2                             ' 2 bytes anfordern/empfangen (repeat start)
      Twi_mr_data = Varptr(twi_rel_buff(1))       ' Puffer fr Relais-Daten
      Gosub Run_wait_master
   Loop Until Twi_mst_flag = 0

Raus4:
Return

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+++++++++++++++++++++++++++ MultiMaster RX/TX Routine +++++++++++++++++++++++++++
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Run_wait_master:
   Gosub Mst_start                                ' Aufruf ( da drin passierts!!)
   Select Case Twi_mst_flag                       ' Ergebnis ?
      Case Twi_m_sent:                            ' (1) gesendet
         Twi_mst_flag = 0
      Case Twi_m_recv:                            ' (2) geholt
         Twi_mst_flag = 0
      Case Else                                   ' irgendein Problem z.B. (3)=timeout
         Incr Fehler_flag                         ' Flag setzen
         Twcr = &B00000000
         Twcr = &B00000100
         Gosub Twi_sense                                ' Slave wieder scharfmachen
   End Select
Return
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++